{"openapi":"3.0.0","info":{"title":"OVHcloud API specification","description":"Specification for OVHcloud API","version":"1.0","contact":{"name":"OVH","email":"api@ml.ovh.net"}},"servers":[{"url":"https://api.eu.ovhcloud.com/v2"}],"components":{"schemas":{"any":{"description":"Can be anything (text, int, bool, json, html, etc.)","example":"This is a content of any type !"},"duration":{"type":"string","description":"Duration (e.g., P1Y2M3DT4H6M9S)","example":"P1Y2M3DT4H6M9S"},"email":{"type":"string","description":"Email address (e.g., api@ml.ovh.net)","format":"email","example":"api@ml.ovh.net"},"iam.group.Creation":{"type":"object","description":"Properties needed to create a group","properties":{"name":{"type":"string","description":"Name of the group"},"resources":{"type":"array","description":"Resources to add in the created group","items":{"$ref":"#/components/schemas/iam.group.Resource"}}},"required":["name"]},"iam.group.Resource":{"type":"object","description":"Resource is an entity standing for a product. It is used for right delegation.","properties":{"displayName":{"type":"string","description":"Resource display name","nullable":true,"readOnly":true},"id":{"type":"string","description":"Unique identifier of the resource","format":"uuid"},"name":{"type":"string","description":"Resource name","nullable":true,"readOnly":true},"owner":{"type":"string","description":"Resource owner","nullable":true,"readOnly":true},"tags":{"type":"object","description":"Resource tags. Tags that were internally computed are prefixed with ovh:","nullable":true,"additionalProperties":{"type":"string"},"readOnly":true},"type":{"type":"string","description":"Resource type. All types can be retrieved at /reference/resource/type.","nullable":true,"readOnly":true},"urn":{"type":"string","description":"Unique resource name used in policies","nullable":true}}},"iam.group.Response":{"type":"object","description":"Group defines a set of resources","properties":{"createdAt":{"type":"string","description":"Creation time","format":"date-time","readOnly":true},"id":{"type":"string","description":"Unique identifier of the group","format":"uuid","readOnly":true},"name":{"type":"string","description":"Name of the group","readOnly":true},"owner":{"type":"string","description":"Owner of the group","readOnly":true},"readOnly":{"type":"boolean","description":"Whether you can add or remove resources","readOnly":true},"resources":{"type":"array","description":"Resources included in the group","items":{"$ref":"#/components/schemas/iam.group.Resource"},"readOnly":true},"updatedAt":{"type":"string","description":"Last update time","nullable":true,"format":"date-time","readOnly":true},"urn":{"type":"string","description":"Unique resource name used in policies","readOnly":true}}},"iam.group.Update":{"type":"object","description":"Fields to update for a given group","properties":{"name":{"type":"string","description":"New name of the group"},"resources":{"type":"array","description":"New list of resources of the group","items":{"$ref":"#/components/schemas/iam.group.Resource"}}},"required":["name","resources"]},"internationalPhoneNumber":{"type":"string","description":"International phone number","format":"phone-number"},"ip":{"type":"string","description":"IP address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipBlock":{"type":"string","description":"IP (v4 or v6) CIDR notation (e.g., 192.0.2.0/24)","format":"ip-block","example":"192.0.2.0/24"},"ipInterface":{"type":"string","description":"IP address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipv4":{"type":"string","description":"IPv4 address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipv4Block":{"type":"string","description":"IPv4 CIDR notation (e.g., 192.0.2.0/24)","format":"ipv4-block","example":"192.0.2.0/24"},"ipv6":{"type":"string","description":"IPv6 address (e.g., 2001:41d0:1:1994::1)","format":"ipv6","example":"2001:41d0:1:1994::1"},"ipv6Block":{"type":"string","description":"IPv6 CIDR notation (e.g., 2001:41d0::/128)","format":"ipv6-block","example":"2001:41d0::/128"},"macAddress":{"type":"string","description":"MAC address (e.g., 00:00:5e:00:53:01)","format":"mac-address","example":"00:00:5e:00:53:01"},"phoneNumber":{"type":"string","description":"Phone number","format":"phone-number"},"time":{"type":"string","description":"Time (e.g., 15:04:05)","format":"time","example":"15:04:05"}},"securitySchemes":{"oAuth2AuthCode":{"type":"oauth2","description":"Oauth2","x-client-id":"1bb9c7df371741c0","x-client-secret":"a5b4de870aca620d10fbf63cd18d205b","flows":{"authorizationCode":{"authorizationUrl":"https://auth.eu.ovhcloud.com/oauth2/authorize","tokenUrl":"https://auth.eu.ovhcloud.com/oauth2/token","scopes":{"account/all":"Manage your account","all":"Manage your whole account and all your services","services/all":"Manage your services lifecycle and billing"}}}}}},"paths":{"/iam/resourceGroup":{"get":{"operationId":"getAllIamResourceGroups","summary":"List resource groups","description":"Returns the resource groups of the account. Set `details` to true to expand resource information.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"header","name":"X-Pagination-Cursor","description":"Pagination cursor","schema":{"type":"string"}},{"in":"header","name":"X-Pagination-Size","description":"Pagination size","schema":{"type":"integer"}},{"in":"query","name":"details","description":"Add extra information about resources in output","schema":{"type":"boolean"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/iam.group.Response"}},"examples":{"List resource group":{"value":[{"createdAt":"2020-03-19T10:45:18.000Z","id":"9167fb26-382b-11ee-895a-0050568ce122","name":"productionDedicatedServers","owner":"aa1-ovh","readOnly":false,"resources":[{"displayName":"DedicatedProd-1","id":"d94d0a7a-382c-11ee-9153-0050568ce122","name":"ns-123456.ip-11.22.33.eu","owner":"ab1-ovh","type":"dedicatedServer","urn":"urn:v1:eu:resource:dedicatedServer:ns-123456.ip-11.22.33.eu"},{"displayName":"DedicatedProd-2","id":"20fae9d2-382d-11ee-8042-0050568ce122","name":"ns-234567.ip-11.22.33.eu","owner":"ab2-ovh","type":"dedicatedServer","urn":"urn:v1:eu:resource:dedicatedServer:ns-234567.ip-11.22.33.eu"}],"updatedAt":"2023-06-08T02:12:02.000Z","urn":"urn:v1:eu:resourceGroup:9167fb26-382b-11ee-895a-0050568ce122"}],"summary":"Response body returned when listing resource groups with details"}}}}}},"tags":["Resources"],"x-developer-hub-navigation":[["Manage & Operate","Identity & Access Management","Policies","Resource Groups@@@10"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.get(\"/v2/iam/resourceGroup\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->get(\"/v2/iam/resourceGroup\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"account:apiovh:iam/resourceGroup/get","required":true}],"x-response-identifier":"id","x-expanded-response":"IamGroupResponse"},"post":{"operationId":"createIamResourceGroup","summary":"Create a resource group","description":"Creates a group of resources that policies can target as a single entity.","security":[{"oAuth2AuthCode":[]}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/iam.group.Creation"},"examples":{"Create a resource group":{"value":{"name":"productionDedicatedServers","resources":[{"id":"d94d0a7a-382c-11ee-9153-0050568ce122"}]},"summary":"Request body used to create a resource group"}}}}},"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/iam.group.Response"},"examples":{"Resource group creation":{"value":{"createdAt":"2020-03-19T10:45:18.000Z","id":"9167fb26-382b-11ee-895a-0050568ce122","name":"productionDedicatedServers","owner":"aa1-ovh","readOnly":false,"resources":[{"id":"d94d0a7a-382c-11ee-9153-0050568ce122"}],"urn":"urn:v1:eu:resourceGroup:9167fb26-382b-11ee-895a-0050568ce122"},"summary":"Response body returned after creating a resource group"}}}}}},"tags":["Resources"],"x-developer-hub-navigation":[["Manage & Operate","Identity & Access Management","Policies","Resource Groups@@@30"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\n# Request body type: iam.group.Creation\nresult = client.post(\"/v2/iam/resourceGroup\",\n\tname = None, # Name of the group (type: string)\n\tresources = None, # Resources to add in the created group (type: array)\n)\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n// Request body type: iam.group.Creation\n$result = $ovh->post(\"/v2/iam/resourceGroup\", array(\n\tname => null, // Name of the group (type: string)\n\tresources => null, // Resources to add in the created group (type: array)\n));\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"account:apiovh:iam/resourceGroup/create","required":true}]}},"/iam/resourceGroup/{groupId}":{"delete":{"operationId":"deleteIamResourceGroup","summary":"Delete a resource group","description":"Deletes the resource group. The resources it contains are not deleted.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"groupId","description":"Group ID","required":true,"schema":{"type":"string","format":"uuid"}}],"responses":{"200":{"description":"successful operation"}},"tags":["Resources"],"x-developer-hub-navigation":[["Manage & Operate","Identity & Access Management","Policies","Resource Groups@@@40"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.delete(\"/v2/iam/resourceGroup/{groupId}\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->delete(\"/v2/iam/resourceGroup/{groupId}\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"account:apiovh:iam/resourceGroup/delete","required":true}]},"get":{"operationId":"getIamResourceGroup","summary":"Get a resource group","description":"Returns the name and the resources of the group. Set `details` to true to expand resource information.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"query","name":"details","description":"Add extra information about resources in output","schema":{"type":"boolean"}},{"in":"path","name":"groupId","description":"Group ID","required":true,"schema":{"type":"string","format":"uuid"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/iam.group.Response"},"examples":{"Get a resource group":{"value":{"createdAt":"2020-03-19T10:45:18.000Z","id":"9167fb26-382b-11ee-895a-0050568ce122","name":"productionDedicatedServers","owner":"aa1-ovh","readOnly":false,"resources":[{"displayName":"DedicatedProd-1","id":"d94d0a7a-382c-11ee-9153-0050568ce122","name":"ns-123456.ip-11.22.33.eu","owner":"ab1-ovh","type":"dedicatedServer","urn":"urn:v1:eu:resource:dedicatedServer:ns-123456.ip-11.22.33.eu"},{"displayName":"DedicatedProd-2","id":"20fae9d2-382d-11ee-8042-0050568ce122","name":"ns-234567.ip-11.22.33.eu","owner":"ab2-ovh","type":"dedicatedServer","urn":"urn:v1:eu:resource:dedicatedServer:ns-234567.ip-11.22.33.eu"}],"updatedAt":"2023-06-08T02:12:02.000Z","urn":"urn:v1:eu:resourceGroup:9167fb26-382b-11ee-895a-0050568ce122"},"summary":"Response body returned when getting a resource group with details"},"Get a resource group without details":{"value":{"createdAt":"2020-03-19T10:45:18.000Z","id":"9167fb26-382b-11ee-895a-0050568ce122","name":"productionDedicatedServers","owner":"aa1-ovh","readOnly":false,"resources":[{"id":"d94d0a7a-382c-11ee-9153-0050568ce122"},{"id":"20fae9d2-382d-11ee-8042-0050568ce122"}],"updatedAt":"2023-06-08T02:12:02.000Z","urn":"urn:v1:eu:resourceGroup:9167fb26-382b-11ee-895a-0050568ce122"},"summary":"Response body returned when getting a resource group without details"}}}}}},"tags":["Resources"],"x-developer-hub-navigation":[["Manage & Operate","Identity & Access Management","Policies","Resource Groups@@@20"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.get(\"/v2/iam/resourceGroup/{groupId}\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->get(\"/v2/iam/resourceGroup/{groupId}\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"account:apiovh:iam/resourceGroup/get","required":true}],"x-response-identifier":"id"},"put":{"operationId":"editIamResourceGroup","summary":"Update a resource group","description":"Replaces the name and the list of resources of the group.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"groupId","description":"Group ID","required":true,"schema":{"type":"string","format":"uuid"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/iam.group.Update"},"examples":{"Edit a resource group":{"value":{"name":"productionDedicatedServersUpdated","resources":[{"id":"20fae9d2-382d-11ee-8042-0050568ce122"}]},"summary":"Request body used to update a resource group"}}}}},"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/iam.group.Response"},"examples":{"Edit resource group":{"value":{"createdAt":"2020-03-19T10:45:18.000Z","id":"9167fb26-382b-11ee-895a-0050568ce122","name":"productionDedicatedServersUpdated","owner":"aa1-ovh","readOnly":false,"resources":[{"id":"20fae9d2-382d-11ee-8042-0050568ce122"}],"updatedAt":"2023-06-08T02:12:02.000Z","urn":"urn:v1:eu:resourceGroup:9167fb26-382b-11ee-895a-0050568ce122"},"summary":"Response body returned after updating a resource group"}}}}}},"tags":["Resources"],"x-developer-hub-navigation":[["Manage & Operate","Identity & Access Management","Policies","Resource Groups@@@50"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\n# Request body type: iam.group.Update\nresult = client.put(\"/v2/iam/resourceGroup/{groupId}\",\n\tname = None, # New name of the group (type: string)\n\tresources = None, # New list of resources of the group (type: array)\n)\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n// Request body type: iam.group.Update\n$result = $ovh->put(\"/v2/iam/resourceGroup/{groupId}\", array(\n\tname => null, // New name of the group (type: string)\n\tresources => null, // New list of resources of the group (type: array)\n));\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"account:apiovh:iam/resourceGroup/edit","required":true}]}}},"tags":[{"name":"Resources","x-tag-expanded":false,"description":"Missing description"}]}
